from flickrapi import FlickrAPI
from urllib.request import urlretrieve
import os, time, sys
from tqdm import tqdm

# APIキーとシークレットを設定
API_KEY = "XXXXXXXXXXXXXXXXXXXX"
SECRET = "XXXXXXXXXXXXXXXXXXXX"

PER_PAGE = 300 # ダウンロードする画像の枚数

wait_time = 1 # インターバル

if len(sys.argv) < 2:
  print('ダウンロードする画像のキーワードが未指定です。')
else:
  # ダウンロードする画像のキーワードを取得する
  keyword = sys.argv[1]
  savedir = "./" + keyword

  # キーワードのフォルダーが無ければ作成
  if os.path.exists(savedir) == False:
    os.mkdir(keyword)

  # FlickrAPIを使って画像情報を取得する
  flickr = FlickrAPI(API_KEY, SECRET, format='parsed-json')
  result = flickr.photos.search(
    text = keyword, # 画像検索用のキーワード
    per_page = PER_PAGE, # 取得する画像の枚数
    media = 'photos',
    sort = 'relevance', # 「関連度が高い順」を指定
    safe_search = 1, # 1＝「不適切コンテンツの除外」を指定
    extras = 'url_q, licence' # 追加で取得したい情報の指定
  )
  # プログレスバーの作成
  pbar = tqdm(range(len(result['photos']['photo'])))

  # URLが存在しなくてダウンロードできない画像をカウント
  er = 0
  for photo, i in zip(result['photos']['photo'], pbar):
    try:
      # 画像のURLを取得
      url_q = photo['url_q']
      # 保存するファイル名を作成
      filepath = savedir + '/' + photo['id'] + '.jpg'
      # 既にファイルが存在するときは何もしない
      if os.path.exists(filepath): continue
      # 画像をダウンロードする
      urlretrieve(url_q, filepath)
      # インターバルをあける
      time.sleep(wait_time)
    except:
      # 画像のURLが存在しない
      er += 1
      continue

  # 結果の表示
  pbar.update()
  print('ダウンロード数：'+str(i+1))
  if 0 < er:
    print('URLの情報無し：'+str(er))


