import sys
import numpy as np
from PIL import Image, ImageOps

def preprocess(image):
  image = ImageOps.fit(image, (32, 32))
  image_arr = np.asarray(image).astype(np.float32)
  image_arr /= 255.
  return np.array([image_arr.transpose(2, 0, 1)])

image_path = sys.argv[1]
image_arr = Image.open(image_path)
input_image = preprocess(image_arr)

import chainer
from train_cifar10 import CNNClassifier
model = CNNClassifier()
chainer.serializers.load_npz('./result/model_iter_50000', model)
categories = ['airplane', 'automobile', 'bird',
  'cat', 'deer', 'dog', 'frog', 'horse', 'ship', 'truck']
answer_ind = model(input_image).data.argmax()
print("ANSWER:", categories[answer_ind])